#!/usr/local/bin/ibsh -f

#global auto_path
#set auto_path [linsert $auto_path 0 /home/wegner/tcl/procedures]

##############################################################################
#
# Build the widget:
#
wm geometry . +200+100
wm title . {GPIB Test}

set width 10

frame .device

label .device.label -text "Device:" -width $width
entry .device.entry -textvariable Device

pack .device -anchor w
pack .device.label .device.entry -side left

frame .status

label .status.label -text "Status:" -width $width
label .status.device -text "no connection"

pack .status -anchor w

pack .status.label .status.device -side left

frame .string

button .string.b -text "Send:" -command Send
entry .string.e -textvariable String

pack .string -anchor w
pack .string.b -side left
pack .string.e -side left -expand 1 -fill x

frame .read

button .read.b -text "Read:" -command Read
label .read.t

pack .read -anchor w

pack .read.b .read.t -side left

frame .rsp

button .rsp.b -text "Serial Poll:" -command SerialPoll
label .rsp.t -text "-"

pack .rsp

pack .rsp.b .rsp.t -side left

frame .comms

button .comms.init -text Init -command Init
button .comms.close -text Close -command Close
button .comms.quit -text Quit -command exit

pack .comms
pack .comms.init .comms.close .comms.quit -side left
#
# End of widget building.
#
############################################################################
#
# Procedures:
#
proc Init {} {
    
    global Device DeviceNo

    set DeviceNo [gpib find $Device]
    .status.device configure -text "$Device ($DeviceNo)"
    gpib sic $DeviceNo
    gpib ren $DeviceNo 1
    gpib clear $DeviceNo
}

proc Send {} {
    
    global String DeviceNo

    gpib write $DeviceNo "$String\x0d"
}

proc Read {} {

    global DeviceNo

    .read.t configure \
	    -text [string trim [gpib read $DeviceNo 20] "\x0d\x0a"]
}

proc SerialPoll {} {

    global DeviceNo

    .rsp.t configure -text [gpib rsp $DeviceNo]
}

proc Close {} {

    global DeviceNo

    gpib close $DeviceNo
    .status.device configure -text "no connection"
}
#
# End of Procedures
#
###########################################################################
#
# Initialisierung:
#
set Device "voltmeter"
Init
gpib write $DeviceNo "D1Hallo"
