#!./ibsh -f

set device [gpib find voltmeter ]

gpib sic   $device
gpib ren   $device 1
gpib clear $device
gpib write $device "D1Ready"
gpib write $device "D0L0Q1OT2"

set result [gpib read $device 12]

set refresh 50
set block 0

proc displ_refresh {} {
	global result device refresh block

	gpib wait $device srq


	.light configure -background red
	update
        set result [gpib read $device 12]
	if { $block == 0 } { 
		after $refresh displ_refresh
        }
	.light configure -background steelblue
	update
}




label  .lab  -text "GPIB Demo" -font -adobe-times-bold-r-normal--18-180-75-75-p-99-iso8859-1
label .light -width 1 -height 1 -relief raised -text "*"
label  .val  -width 15 -textvariable result -relief sunken -font -adobe-helvetica-bold-r-normal--24-240-75-75-p-138-iso8859-1

button .but1 -text "Quit" -command { set block 1; update idletasks ;gpib close $device ; exit}
button .but2 -text "Ohm"  -command {gpib write $device "O2" }
button .but3 -text "V~"   -command { gpib write $device "VA" }
button .but4 -text "V="   -command { gpib write $device "VD" }
button .but5 -text "A~"   -command { gpib write $device "IA" }
button .but6 -text "A="   -command { gpib write $device "ID" }
button .but7 -text "AON"  -command { gpib write $device "A1" }
button .but8 -text "AOFF" -command { gpib write $device "A0" }


pack append . .lab { top fillx} .val { top fillx } .light {right fillx }  
pack append . .but1 { bottom fillx } .but2 { bottom fillx } .but3 { bottom fillx } \
              .but4 { bottom fillx} .but5 { bottom fillx} .but6 { bottom fillx} \
	      .but7 { top filly } .but8 { top filly }
displ_refresh










