'\" Copyright 1990 Regents of the University of California
'\" Permission to use, copy, modify, and distribute this
'\" documentation for any purpose and without fee is hereby
'\" granted, provided that this notice appears in all copies.
'\" The University of California makes no representations about
'\" the suitability of this material for any purpose.  It is
'\" provided "as is" without express or implied warranty.
'\" 
'\" $Header: /user6/ouster/wish/man/RCS/menu.man,v 1.4 91/10/31 14:12:19 ouster Exp $ SPRITE (Berkeley)
'/" 
.\" The definitions below are for supplemental macros used in Sprite
.\" manual entries.
.\"
.\" .HS name section [date [version]]
.\"	Replacement for .TH in other man pages.  See below for valid
.\"	section names.
.\"
.\" .AP type name in/out [indent]
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS [type [name]]
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .VS
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
'	# Heading for Sprite man pages
.de HS
.if '\\$2'cmds'       .TH \\$1 1 \\$3 \\$4
.if '\\$2'lib'        .TH \\$1 3 \\$3 \\$4
.if '\\$2'tcl'        .TH \\$1 3 \\$3 \\$4
.if '\\$2'tk'         .TH \\$1 3 \\$3 \\$4
.if t .wh -1.3i ^B
.nr ^l \\n(.l
.ad b
..
'	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ie !"\\$3"" \{\
.ta \\n()Au \\n()Bu
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
'	# BS - start boxed text
'	# ^y = starting y location
'	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'	# VS - start vertical sidebar
'	# ^Y = starting y location
'	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'	# Special macro to handle page bottom:  finish off current
'	# box/sidebar if in box/sidebar mode, then invoked standard
'	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'	# DS - begin display
.de DS
.RS
.nf
.sp
..
'	# DE - end display
.de DE
.fi
.RE
.sp .5
..
.HS dll tcl
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
dll \- tcl command for dynamic loading of a tcl module

.SH SYNOPSIS
\fBdll\fI \fIcommand module \fR[\fIpath\fR]
.SH "COMMANDS"
.LP
.nf
.ta 4c 8c 12c
\fBload\fR	\fBunload\fR	\fBset\fR
.fi
.LP
.BE
.SH "INTRODUCTON"
.ta 4c
.IP
The Dll Extension to Tcl enables the user to load Tcl-Modules into the interpreter
at Runtime and unload it if they aren't needed anymore. To implement this command 
the GNU dld library is used. This provides a easier way to
Implement Extensions to Tcl/Tk because the interpreter need not to be recompiled for this.

A Tcl-Module means a piece of code that can add and remove commands to the interpreter. 
Adding commands is done while loading and removing Commands is done while unloading the Module.
The module must provide two essential functions for this: a \fBmodule_init\fR and a
\fBmodule_cleanup\fR function. \fBmodule_init\fR is usualy used to create Tcl Commands
that should be provided by the Module and doing the initial setup for the Module (similar
to Mod_Init() in tclAppInit() ). \fBmodule_cleanup\fR should do all the dirty work before the
Module is removed from Memory as Deleting Tcl Commands, freeing Memory etc.

.LP
.SH "DESCRIPTION"
.ta 4c
.LP
.nf
\fBload\fR \fBmodule\fR
.fi
.IP
Loads the desired Module into the Interpreter. The Module _init function is called.
.LP
.nf
\fBunload\fR  \fBmodule\fR
.fi
.IP
Removes the Module from interpreter. The Module _cleanup function is called.
.LP
.nf
.fi
\fBset\fR  \fBpath\fR    \fBNewValue\fR
.fi
.IP
Sets the default loading Path for Modules
.LP
.nf
.fi
\fBset\fR  \fBsuffix\fR    \fBNewValue\fR
.fi
.IP
Sets the default suffix for Module files (Normally '.o')
.LP
.nf
.fi
.IP
If the Loader detects undefined Symbols while loading the loading process will be aborted
and the undefined Symbols will be reported in a Error Message. 
.LP
.SH SAMPLE
.IP
The next simple Example shows how the init and cleanup functions are used.
.LP
.DS

/***********************************************************************
 *   Stupid Test Module for Dll Extension to Tk.
 *
 *   (c) 1994 by C.Schroeter (clausi@chemie.fu-berlin.de)
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <tcl.h>

/***********************************************************************
 *  dlltest_init - Init routine for the Module
 *	creates a Tcl command 'dlltest'
 *
 */

int dlltest_init ( Tcl_Interp *interp ){                  

extern int DllTestCmd _ANSI_ARGS_(( ClientData clientData,
                              Tcl_Interp *interp,
                               int argc,
                               char *argv[]
                               ));

    Tcl_CreateCommand(interp,"dlltest",DllTestCmd,
                         (ClientData) NULL,
                         (Tcl_CmdDeleteProc *) NULL );
    return TCL_OK;
}

/***********************************************************************
 *  dlltest_cleanup - Cleanup routine for the Module
 *	Deletes the 'dlltest' from the interpreter
 *
 */

int dlltest_cleanup ( Tcl_Interp *interp ){

  Tcl_DeleteCommand(interp,"dlltest");

  return TCL_OK;
}

/***********************************************************************
 *  The 'dlltest' command
 *	prints a silly message
 *
 */


int DllTestCmd _ANSI_ARGS_(( ClientData clientData,
                              Tcl_Interp *interp,
                               int argc,
                               char *argv[]
                               )) 
{
  printf("dlltest_called !");
  return TCL_OK;
}

/**end******************************************************************/


.DE
.IP
To use this Module compile it using your C compiler:
.LP
.DS
cc -c dlltest.c
.DE
.IP
The Result will be an object file \fBdlltest.o\fR that can be loaded
with the Tcl command:
.LP
.DS
dll load dlltest 
.DE
.IP
Or if the module is not in your current path but in /usr/lib/modules:
.LP
.DS
dll load dlltest /usr/lib/modules
.DE
.IP
After this the user can call the \fBdlltest\fR Command and gets back the stupid Message.
Realize that the basename of the object file and the _init/_cleanup prefix must be identical.

If a module consists of more than one Object file you must build a relocatable Object Library
(Partial linking) use the ld's -r Option to do this.
.LP
.DS
ld -o mymodule.o -r object1.o object2.o .... objectn.o
.DE


.SH KEYWORDS
modules, dynamic loading, dld-library, partial linking

.SH BUGS
.PP
Module Names must not be larger than 20 characters.
As Modules are Loaded entirely to  Process Heap it is recommended to hold Modules as small as possible
in other words symbols that will not be used by the Module should be avoided.






